/*!\file
 * \brief    ,           Can.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include "can_test.h"


CAN_T * can0 = (CAN_T*)BasicCAN_0;
CAN_T * can1 = (CAN_T*)BasicCAN_1;
CAN_EXTANDED_T * pelican0 = (CAN_EXTANDED_T*)PeliCAN_0;
CAN_EXTANDED_T * pelican1 = (CAN_EXTANDED_T*)PeliCAN_1;

CAN_T * basic_can[2] = {(CAN_T*)BasicCAN_0, (CAN_T*)BasicCAN_1};
CAN_EXTANDED_T * peli_can[2] = {(CAN_EXTANDED_T*)PeliCAN_0, (CAN_EXTANDED_T*)PeliCAN_1};
#define BUF_LEN         10
char receive_buffer[BUF_LEN][13];
unsigned int buf_pos_rx = 0;
unsigned int buf_pos_tx = 0;
unsigned int rx_flag[2] = {0, 0};


void irq_handler(int index)
{
    for (unsigned int wait = 0; wait < 100; wait++);
        
    if (basic_can[index]->INTERRUPT&0x1 == 1)
    {             
        rx_flag[index] = 1;
        //   fifo   
        if (basic_can[index]->Clock_divider & (1<<7)) //extended 
        {
            receive_buffer[buf_pos_rx][0] = peli_can[index]->FI_SFF_FI_EFF_Acceptance_code_0;
            receive_buffer[buf_pos_rx][1] = peli_can[index]->ID_1_Acceptance_code_1;
            receive_buffer[buf_pos_rx][2] = peli_can[index]->ID_2_Acceptance_code_2;
            receive_buffer[buf_pos_rx][3] = peli_can[index]->Data1_ID_3_Acceptance_code_3;
            receive_buffer[buf_pos_rx][4] = peli_can[index]->Data2_ID_4_Acceptance_mask_0;
            receive_buffer[buf_pos_rx][5] = peli_can[index]->Data3_Data1_Acceptance_mask_1;
            receive_buffer[buf_pos_rx][6] = peli_can[index]->Data4_Data2_Acceptance_mask_2;
            receive_buffer[buf_pos_rx][7] = peli_can[index]->Data5_Data3_Acceptance_mask_3;
            receive_buffer[buf_pos_rx][8] = peli_can[index]->Data6_Data4;
            receive_buffer[buf_pos_rx][9] = peli_can[index]->Data7_Data5;
            receive_buffer[buf_pos_rx][10] = peli_can[index]->Data8_Data6;
            receive_buffer[buf_pos_rx][11] = peli_can[index]->FIFO1_Data7;
            receive_buffer[buf_pos_rx][12] = peli_can[index]->FIFO2_Data8;
          }
          else //basic 
          {
            receive_buffer[buf_pos_rx][0] = basic_can[index]->RX_id1;
            receive_buffer[buf_pos_rx][1] = basic_can[index]->RX_id2_rtr_dlc;
            receive_buffer[buf_pos_rx][2] = basic_can[index]->RX_data_byte_1;
            receive_buffer[buf_pos_rx][3] = basic_can[index]->RX_data_byte_2;
            receive_buffer[buf_pos_rx][4] = basic_can[index]->RX_data_byte_3;
            receive_buffer[buf_pos_rx][5] = basic_can[index]->RX_data_byte_4;
            receive_buffer[buf_pos_rx][6] = basic_can[index]->RX_data_byte_5;
            receive_buffer[buf_pos_rx][7] = basic_can[index]->RX_data_byte_6;
            receive_buffer[buf_pos_rx][8] = basic_can[index]->RX_data_byte_7;
            receive_buffer[buf_pos_rx][9] = basic_can[index]->RX_data_byte_8;
            receive_buffer[buf_pos_rx][10] = 0x00;                   
          } 
          buf_pos_rx %= BUF_LEN;
          basic_can[index]->COMMAND = (1 << 2); //  
          receive_buffer[0][10]=0;
          PRINT(">>>    CAN: %s", &receive_buffer[0][2]);
       }
}


void CAN1_IRQ()
{
        irq_handler(0);    
}

void CAN2_IRQ()
{
        irq_handler(1);    
}

//   CAN      
void Init_ports_CAN(unsigned int mode)
{ 
    if (mode == 0) //altfunc 1
    {
        GPIO_E->ALTFUNCCLR = (1 << 14) | (1 << 15);
        GPIO_F->ALTFUNCCLR = (1 << 0) | (1 << 1);                
        GPIO_G->ALTFUNCCLR = (1 << 12) | (1 << 13) | (1 << 14) | (1 << 15);
        GPIO_E->OUTENCLR = (1 << 14) | (1 << 15);
        GPIO_F->OUTENCLR = (1 << 0) | (1 << 1);                
        GPIO_G->OUTENCLR = (1 << 12) | (1 << 13) | (1 << 14) | (1 << 15);                 
        GPIO_H->ALTFUNCSET = (1 << 10) | (1 << 11) | (1 << 12) | (1 << 13);                 
    }
    else if (mode == 1) //atlfunc 2
    {
        GPIO_H->ALTFUNCCLR |= (1 << 10) | (1 << 11) | (1 << 12) | (1 << 13);
        GPIO_G->ALTFUNCCLR |= (1 << 12) | (1 << 13) | (1 << 14) | (1 << 15);
        GPIO_H->OUTENCLR |= (1 << 10) | (1 << 11) | (1 << 12) | (1 << 13);
        GPIO_G->OUTENCLR |= (1 << 12) | (1 << 13) | (1 << 14) | (1 << 15);               
        CMN_REG->ALT_FUNCTION_CTRL[4] |= 0x50000000;
        CMN_REG->ALT_FUNCTION_CTRL[5] |= 0x00000005;       
        GPIO_E->ALTFUNCSET |= (1 << 14) | (1 << 15);
        GPIO_F->ALTFUNCSET |= (1 << 0) | (1 << 1);         
    }
    else if (mode == 2) //atlfunc 3
    {  
        GPIO_H->ALTFUNCCLR |= (1 << 10) | (1 << 11) | (1 << 12) | (1 << 13);
        GPIO_E->ALTFUNCCLR |= (1 << 14) | (1 << 15);
        GPIO_F->ALTFUNCCLR |= (1 << 0) | (1 << 1);                
        GPIO_G->ALTFUNCCLR |= (1 << 12) | (1 << 13) | (1 << 14) | (1 << 15);
        GPIO_E->OUTENCLR |= (1 << 14) | (1 << 15);
        GPIO_F->OUTENCLR |= (1 << 0) | (1 << 1);                
        GPIO_G->OUTENCLR |= (1 << 12) | (1 << 13) | (1 << 14) | (1 << 15);   
        GPIO_H->OUTENCLR |= (1 << 10) | (1 << 11) | (1 << 12) | (1 << 13);
        CMN_REG->ALT_FUNCTION_CTRL[6] |= 0xAA000000;         
        GPIO_G->ALTFUNCSET |= (1<<12)|(1<<13)|(1 << 14) | (1 << 15);
    }
}

void testFilter(int index,int id)
{
      basic_can[index]->ACEPTANCE_CODE = id;
      basic_can[index]->ACEPTANCE_MASK = 0x00;
}

#define BASIC           0
#define EXTENDED        1
#define CAN_MODE    BASIC   // EXTENDED
void CAN_to_USB_Test()
{
        NVIC_EnableIRQ(CAN1_NUM,18);
        //NVIC_EnableIRQ(CAN2_NUM,20);
        
        CMN_REG->PWR_CTRL_CLK |= (1<<20); //CAN1
        CMN_REG->PWR_CTRL_RST |= (1<<20);
        
        //CMN_REG->PWR_CTRL_CLK |= (1<<21); //CAN2
        //CMN_REG->PWR_CTRL_RST |= (1<<21);
        
        basic_can[0]->CONTROL = 1;       //reset 
// 1 Mbit speed         0.5 Mbit   0.1 Mbit     //0.05Mbit
#define BRP    7 //7       //15       //39     57  
#define TSEG1  1 //1       //1       //3        6
#define TSEG2  1 //1       //1       //4        5
        
        basic_can[0]->BUS_TIMING_0 = (BRP << 0) | (1 << 6);
        basic_can[0]->BUS_TIMING_1 = (TSEG1 << 0) | (TSEG2 << 4) | (0 << 7);
                
        basic_can[0]->Clock_divider = 0; //basic 
        basic_can[0]->ACEPTANCE_CODE = 0x00;
        basic_can[0]->ACEPTANCE_MASK = 0xFF;
        basic_can[0]->CONTROL = 0x1E;
        
        basic_can[0]->TX_id1 = 0x55;
        basic_can[0]->TX_id2_rtr_dlc = (3 << 5) | (0 << 4) | (8 << 0);
        basic_can[0]->TX_data_byte_1 = 0xaa;
        basic_can[0]->TX_data_byte_2 = 0xaa;
        basic_can[0]->TX_data_byte_3 = 0xaa;
        basic_can[0]->TX_data_byte_4 = 0xaa;
        basic_can[0]->TX_data_byte_5 = 0xaa;
        basic_can[0]->TX_data_byte_6 = 0xaa;
        basic_can[0]->TX_data_byte_7 = 0xbb;
        basic_can[0]->TX_data_byte_8 = 0xbb;
        
        basic_can[0]->COMMAND = 1;
                
        for (unsigned int index = 0; index < 2; index++)
        {
            basic_can[index]->CONTROL = 1;       //reset 
#define BRP     7
#define TSEG1   1
#define TSEG2   1
            basic_can[index]->BUS_TIMING_0 = (BRP << 0) | (1 << 6);
            basic_can[index]->BUS_TIMING_1 = (TSEG1 << 0) | (TSEG2 << 4) | (0 << 7);
                
#if (CAN_MODE == BASIC)
            basic_can[index]->Clock_divider = 0; //basic 
            basic_can[index]->ACEPTANCE_CODE = 0x00;
            basic_can[index]->ACEPTANCE_MASK = 0xFF;
            
            
       //   testFilter(index,0x05);                                             //   -   -   !             
            
            
            basic_can[index]->CONTROL = 0x1E; //reset off, all irqs enabled
#else
            peli_can[index]->Clock_divider = (1 << 7); //extended 
            peli_can[index]->FI_SFF_FI_EFF_Acceptance_code_0  = 0x00;
            peli_can[index]->ID_1_Acceptance_code_1               = 0x00;
            peli_can[index]->ID_2_Acceptance_code_2               = 0x00;
            peli_can[index]->Data1_ID_3_Acceptance_code_3         = 0x00;
            peli_can[index]->Data2_ID_4_Acceptance_mask_0         = 0xFF;
            peli_can[index]->Data3_Data1_Acceptance_mask_1       = 0xFF;
            peli_can[index]->Data4_Data2_Acceptance_mask_2       = 0xFF;
            peli_can[index]->Data5_Data3_Acceptance_mask_3       = 0xFF;
                
            peli_can[index]->Interrupt_enable = 0xFF;
            peli_can[index]->Mode = 0;
#endif
            rx_flag[index] = 0;
        } 
        // 
        unsigned int ID = 0;
        unsigned int length;
        unsigned int FF;
        unsigned int RTR;
        while(1)
        {
            for (unsigned int index = 0; index < 1; index++)
                if (rx_flag[index]) // 
                    {
                        rx_flag[index] = 0;              
#if (CAN_MODE == BASIC)                                
                        ID = (receive_buffer[buf_pos_tx][0] << 3) | (receive_buffer[buf_pos_tx][1] >> 5);
                        length = receive_buffer[buf_pos_tx][1] & 0xF;                                
                        // 
                        basic_can[index]->TX_id1 = receive_buffer[buf_pos_tx][0];//ID >> 3; //id[10:3]
                        basic_can[index]->TX_id2_rtr_dlc = receive_buffer[buf_pos_tx][1];//((ID & 0x7) << 5) | (0 << 4) | (length << 0); //id[2:0] = 3, rtr = 0, length = 7
                        basic_can[index]->TX_data_byte_1 = receive_buffer[buf_pos_tx][2];
                        basic_can[index]->TX_data_byte_2 = receive_buffer[buf_pos_tx][3];
                        basic_can[index]->TX_data_byte_3 = receive_buffer[buf_pos_tx][4];
                        basic_can[index]->TX_data_byte_4 = receive_buffer[buf_pos_tx][5];
                        basic_can[index]->TX_data_byte_5 = receive_buffer[buf_pos_tx][6];
                        basic_can[index]->TX_data_byte_6 = receive_buffer[buf_pos_tx][7];
                        basic_can[index]->TX_data_byte_7 = receive_buffer[buf_pos_tx][8];
                        basic_can[index]->TX_data_byte_8 = receive_buffer[buf_pos_tx][9];
                        basic_can[index]->COMMAND = 1;
#endif        
                        buf_pos_tx++;
                        buf_pos_tx %= BUF_LEN;
                    }
        }
}
