/*!\file
 * \brief    ,          I2C.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */


#include "i2c_test.h"
#include "i2c.h"

volatile uint32_t data_rx_check=0;
volatile uint32_t data_tx_check=0;

void Test_I2C()
{
    PRINT("**********   I2C **********");
  
    unsigned int errors = 0;
         
    unsigned char Bus_switch_addr = 0x27;
    unsigned char Bus_switch_tx_data = 0x00;
    unsigned char Bus_switch_rx_data = 0;

    for (int r=0; r<0xFF;r++)
    {
      Bus_switch_tx_data++;
      if (I2C_Write_Byte(Bus_switch_addr, Bus_switch_tx_data))
      {
        errors++;
      }
      if (I2C_Read_Byte(Bus_switch_addr, &Bus_switch_rx_data))
      {
        errors++;
      }
      if (Bus_switch_rx_data != Bus_switch_tx_data)
      {
        errors++;
      }
    }
    PRINT(">>>   ");
    PRINT(">>> : %X",errors);
    DBG_TX_Flush();
}
