/*!\file
 * \brief          .
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include "watchdog_test.h"
/**
 * \brief  WatchDog
 *
 *      .
 *      :
 *                    -    
 *                    -      
 *                    -     
 *                   -     
 *                      10 , 
 *                   -   ,        
 *                
 *                    -   ,    
 *                     (     -   )
 *                    -   WatchDog (   )
 *                  
 *      ,    .
 *          Workspace: 
 *                      - periph_watchdog_ram -    
 *                      - periph_watchdog_ext -        
 */


int main()
{
    SystemInit2();                                                               //  
    clockInit();                                                                //   
    DBG_UART_Init();                                                            //  UART  
    gpioInit();                                                                 //  GPIO
  
    Test_Watchdog();                                                            //  Watchdog
  
    while(1) 
    {
        DBG_TX_Flush();                                                         //   ,    ,   UART    }
    }
}
