/*!\file
 * \brief            SPI.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include "spi_test.h" 


/**
 * \brief  SPI
 *
 *     SPI
 *  
 *     SPI   SPI1  SPI2
 *   :
 *		SPI1_SCK  SPI2_SCK;
 *		SPI1SS_EXT  SPI2SS_EXT
 *		SPI1_MISO  SPI2_MOSI
 *		SPI1_MOSI  SPI2_MISO
 *
 *     3- :
 *                    -  
 *                    -   
 *                    -   DMA
 *      :
 *                    -  SPI
 *                    -  SPI
 *                    -   1...255
 *                    -  
 *                    -   -   
 *                  e ,    
 *                  -   
 *       
 *      ,    .
 *          Workspace: 
 *                      - periph_ssp_ram -    
 *                      - periph_ssp_ext -       
 */
void main()
{
    SystemInit();                                                               //   
    clockInit();                                                                //   
    DBG_UART_Init();                                                            //  UART  
    gpioInit();                                                                 //  GPIO
    
    SPI_Test();                                                                 //  SPI
  
    while(1) 
    {
        DBG_TX_Process();                                                       //  ,    ,   UART
    }
}