/*!\file
 * \brief    ,         .
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#ifndef TYPES_H_
#define TYPES_H_

#include <stdint.h>
#include <stdbool.h>



#define     __RO     volatile const                                             /*!<                  */
#define     __WO     volatile                                                   /*!<                  */
#define     __RW     volatile                                                   /*!<   /              */

/**
 * @brief    /   
 */
#if !defined(MAX)
#define MAX(a, b) (((a) > (b)) ? (a) : (b))
#endif
#if !defined(MIN)
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#endif


#define PORT_A 0        ///<  A
#define PORT_B 1        ///<  B
#define PORT_C 2        ///<  C
#define PORT_D 3        ///<  D
#define PORT_E 4        ///<  E
#define PORT_F 5        ///<  F
#define PORT_G 6        ///<  G
#define PORT_H 7        ///<  H

/**
 * @brief    
 */
typedef enum {RESET = 0, SET = 1} FlagStatus, IntStatus, SetState;
#define PARAM_SETSTATE(State) ((State == RESET) || (State == SET))

/**
 * @brief    
 */
typedef enum {DISABLE = 0, ENABLE = !DISABLE} FunctionalState;
#define PARAM_FUNCTIONALSTATE(State) ((State == DISABLE) || (State == ENABLE))

/**
 * @brief    
 */
typedef enum {ERROR = 0, SUCCESS = !ERROR} Status;

#endif