/*!\file
 * \brief           SpaceWire.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include "chip_5023BC016.h"
#include "system.h"
#include "spacewire.h"



/*****************************************************************************
 *  
 ****************************************************************************/

/*        /      */
static CTRL_T SPW_GetCtrlNum(SPW_T *pSPW)
{
    CTRL_T CtrlSSP;
    if (pSPW == SPW1) 
    {
	CtrlSSP = Spacewire_1_CTRL_NUM;
    }
    else 
    {
	CtrlSSP = Spacewire_2_CTRL_NUM;
    }
    return CtrlSSP;
}

/*****************************************************************************
 *  
 ****************************************************************************/

/*  SSP */
void SPW_Init(SPW_T *pSPW)
{
    PWR_CLK_Enable(SPW_GetCtrlNum(pSPW));                                       /**<    */
    CLK_INIT_PAUSE;  
    PWR_RST_Disable(SPW_GetCtrlNum(pSPW));                                      /**<    */
}

/**
 * @brief     Spacewire
 * @param freq_num :    
 * 0       SW_CLK (PORTH[4]).
 * 1      
 */
void SPW_freq(uint8_t freq_num)
{
    CMN_REG->SPACEWIRE_CLK_CTRL &= ~SPACEWIRE_CLK_CTRL(freq_num);
    CMN_REG->SPACEWIRE_CLK_CTRL |=  SPACEWIRE_CLK_CTRL(freq_num);               //   
}

/*  SSP */
void SPW_DeInit(SPW_T *pSPW)
{
    PWR_CLK_Disable(SPW_GetCtrlNum(pSPW)); CLK_INIT_PAUSE;
    PWR_RST_Enable(SPW_GetCtrlNum(pSPW));
}

